/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { AnnotationLayer } from "./AnnotationLayer";
import { Brush } from "igniteui-react-core";
import { DependencyProperty } from "igniteui-react-core";
import { Series } from "./Series";
import { Thickness } from "igniteui-react-core";
import { Visibility_$type } from "igniteui-react-core";
import { CrosshairLayerFrame } from "./CrosshairLayerFrame";
import { List$1 } from "igniteui-react-core";
import { Axis } from "./Axis";
import { Dictionary$2 } from "igniteui-react-core";
import { Pool$1 } from "igniteui-react-core";
import { AxisAnnotation } from "./AxisAnnotation";
import { Base, Number_$type, enumGetBox, fromEnum, Point_$type, markType, markDep, runOn } from "igniteui-react-core";
import { AxisAnnotationFrameManager } from "./AxisAnnotationFrameManager";
import { Tuple$2 } from "igniteui-react-core";
import { DoubleCollection } from "igniteui-react-core";
import { DeviceUtils } from "igniteui-react-core";
import { Path } from "igniteui-react-core";
import { PathGeometry } from "igniteui-react-core";
import { PathFigure } from "igniteui-react-core";
import { LineSegment } from "igniteui-react-core";
import { PropertyMetadata } from "igniteui-react-core";
import { isNaN_, truncate } from "igniteui-react-core";
import { AnnotationLayerView } from "./AnnotationLayerView";
import { Defaults } from "./Defaults";
import { TranslateTransform } from "igniteui-react-core";
import { LineGeometry } from "igniteui-react-core";
import { BrushUtil } from "igniteui-react-core";
import { Color } from "igniteui-react-core";
/**
 * @hidden
 */
var CrosshairLayer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CrosshairLayer, _super);
    function CrosshairLayer() {
        var _this = _super.call(this) || this;
        _this.xAxisAnnotationFormatLabel = null;
        _this.yAxisAnnotationFormatLabel = null;
        _this.aci = null;
        _this.z5 = null;
        _this.z4 = null;
        var a = new CrosshairLayerFrame();
        var b = new CrosshairLayerFrame();
        var c = new CrosshairLayerFrame();
        var d = _this.kd / 1000;
        _this.xa = a;
        _this.w9 = b;
        _this.xb = c;
        _this.ab = CrosshairLayer.$;
        return _this;
    }
    CrosshairLayer.prototype.bj = function () {
        return new CrosshairLayer();
    };
    CrosshairLayer.prototype.get_er = function () {
        return true;
    };
    CrosshairLayer.prototype.get_ep = function () {
        return true;
    };
    CrosshairLayer.prototype.cs = function () {
        return new CrosshairLayerView(this);
    };
    CrosshairLayer.prototype.qz = function (a) {
        _super.prototype.qz.call(this, a);
        this.zx = a;
    };
    CrosshairLayer.prototype.gu = function (a) {
        if (this.zy == null) {
            return true;
        }
        if (this.zy == a) {
            return true;
        }
        return false;
    };
    CrosshairLayer.prototype.zz = function () {
        return this.xAxisAnnotationFormatLabel != null;
    };
    CrosshairLayer.prototype.z0 = function () {
        return this.yAxisAnnotationFormatLabel != null;
    };
    Object.defineProperty(CrosshairLayer.prototype, "ack", {
        get: function () {
            return new Thickness(1, this.z8, this.aaa, this.z9, this.z7);
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CrosshairLayer.prototype, "acl", {
        get: function () {
            return new Thickness(1, this.aae, this.aag, this.aaf, this.aad);
        },
        enumerable: false,
        configurable: true
    });
    CrosshairLayer.prototype.yn = function (a, b) {
        if (this.zy == null || this.zy == a) {
            if (!this.a1.c) {
                this.rp(b);
            }
        }
    };
    CrosshairLayer.prototype.yp = function (a, b) {
        var e_1, _a;
        var _this = this;
        _super.prototype.yp.call(this, a, b);
        var c = a;
        var d = this.z3;
        var e = this.z2;
        c.af.clear();
        c.ag.clear();
        c.ae.clear();
        c.ah.clear();
        AxisAnnotationFrameManager.b(c);
        if (this.xg(this.zy)) {
            this.abf(this.zy, c, d, e);
        }
        else {
            try {
                for (var _b = __values(fromEnum(this.db.series)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var f = _c.value;
                    if (this.xg(f)) {
                        this.abf(f, c, d, e);
                    }
                    if (f.isStacked) {
                        f.p1(function (g) {
                            if (_this.xg(g)) {
                                _this.abf(g, c, d, e);
                            }
                            if (g.eg) {
                                g.pz(function (h) {
                                    if (_this.xg(h)) {
                                        _this.abf(h, c, d, e);
                                    }
                                    return true;
                                });
                            }
                            return true;
                        });
                    }
                    if (f.eg) {
                        f.pz(function (g) {
                            if (_this.xg(g)) {
                                _this.abf(g, c, d, e);
                            }
                            return true;
                        });
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
    };
    CrosshairLayer.prototype.xg = function (a) {
        if (!_super.prototype.xg.call(this, a)) {
            return false;
        }
        if (this.aao != null) {
            if (a.fb) {
                var b = a.nc();
                if (!Base.equalsStatic(this.aao, b)) {
                    return false;
                }
            }
            else {
                if (!Base.equalsStatic(this.aao, a.name)) {
                    return false;
                }
            }
        }
        var c = this.yi(a);
        if (!c.c) {
            return false;
        }
        return true;
    };
    CrosshairLayer.prototype.qn = function () {
        _super.prototype.qn.call(this);
        if (!this.a1.c && !this.d3()) {
            return;
        }
        if (this.d3()) {
            this.abg(this.xb, false);
        }
        else {
            this.abg(this.w9, false);
        }
    };
    CrosshairLayer.prototype.w0 = function () {
        return 1;
    };
    CrosshairLayer.prototype.xn = function () {
        return 0.1;
    };
    CrosshairLayer.prototype.xq = function () {
        return -0.4;
    };
    CrosshairLayer.prototype.xp = function () {
        return 0.5;
    };
    CrosshairLayer.prototype.zm = function () {
        return this.wx == 3 ? this.acj() : null;
    };
    CrosshairLayer.prototype.zn = function () {
        return this.wy == 3 ? this.acj() : null;
    };
    CrosshairLayer.prototype.acj = function () {
        if (this.aci == null) {
            this.aci = new DoubleCollection();
            this.aci.add(DeviceUtils.g(5));
            this.aci.add(DeviceUtils.g(5));
        }
        return this.aci;
    };
    CrosshairLayer.prototype.abf = function (a, b, c, d) {
        var e = this.yi(a);
        if (!e.c) {
            return;
        }
        var f = e.d;
        f = a.wa(f, c, d);
        var g = false;
        var h = this.u7;
        if (h == null) {
            h = this.vd;
        }
        if (h == null) {
            h = a.u7;
            g = true;
        }
        var i = false;
        var j = this.acc;
        if (j == null) {
            if (this.vd != null) {
                j = this.vd;
            }
            else {
                j = a.u7;
                i = true;
            }
        }
        var k = false;
        var l = this.acf;
        if (l == null) {
            if (this.vd != null) {
                l = this.vd;
            }
            else {
                l = a.u7;
                k = true;
            }
        }
        var m = h;
        var n = h;
        var o = j;
        var p = l;
        if (this.aca != null) {
            m = this.aca;
        }
        else if (g) {
            switch (this.wx) {
                case 0:
                case 1:
                    m = this.zx.ce(m, this.xk);
                    break;
                case 2:
                    m = this.zx.cg(m, this.xk);
                    break;
                case 4:
                    m = this.zx.cf(m, this.xk);
                    break;
            }
        }
        if (this.acb != null) {
            n = this.acb;
        }
        else if (g) {
            switch (this.wy) {
                case 0:
                case 1:
                    n = this.zx.ce(n, this.xm);
                    break;
                case 2:
                    n = this.zx.cg(n, this.xm);
                    break;
                case 4:
                    n = this.zx.cf(n, this.xm);
                    break;
            }
        }
        if (i) {
            switch (this.wy) {
                case 1:
                    o = this.zx.ce(o, this.xm);
                    break;
                case 2:
                    o = this.zx.cg(o, this.xm);
                    break;
            }
        }
        if (k) {
            switch (this.wx) {
                case 1:
                    p = this.zx.ce(p, this.xk);
                    break;
                case 2:
                    p = this.zx.cg(p, this.xk);
                    break;
            }
        }
        b.ae.add(m);
        b.ah.add(n);
        b.af.add(f.y);
        b.ag.add(f.x);
        if (this.z1 && !isNaN_(f.y)) {
            AxisAnnotationFrameManager.c(b, f, a, this.db, this.getEffectiveViewport(), h, o, this.z6, this.ace, this.acd, this.ack, this.aab, p, this.aac, this.ach, this.acg, this.acl, this.aah, this.acn == 0, this.acm == 0);
        }
    };
    CrosshairLayer.prototype.abg = function (a, b) {
        var c = false;
        if (this.z4 == null) {
            c = true;
            this.z5 = new List$1(Axis.$, 0);
            this.z4 = new Dictionary$2(Axis.$, Pool$1.$.specialize(AxisAnnotation.$), 0);
        }
        AxisAnnotationFrameManager.d(this, a, c, this.z4, this.z5, b, this.aai, this.aaj, this.xAxisAnnotationFormatLabel, this.yAxisAnnotationFormatLabel);
    };
    CrosshairLayer.prototype.abe = function (a, b, c, d, e) {
        var f = a.item(b);
        b++;
        if (e) {
            f._stroke = d.ah._inner[c];
            f._fill = d.ah._inner[c];
        }
        else {
            f._stroke = d.ae._inner[c];
            f._fill = d.ae._inner[c];
        }
        f.ad = this.ie;
        f.ai = e ? this.zl : this.zk;
        f.am = this.v3;
        f.al = this.v2;
        f.ak = this.v2;
        f.aj = this.v1;
        f.ac = this.jh;
        return new Tuple$2(Path.$, Number_$type, f, b);
    };
    CrosshairLayer.prototype.ys = function (a, b) {
        _super.prototype.ys.call(this, a, b);
        var c = this.zx.b8;
        var d = a;
        var e = d.af.count;
        var f = 0;
        var g = b.bx.left;
        var h = b.bx.right;
        var i = b.bx.top;
        var j = b.bx.bottom;
        var k = this.acn == 0;
        var l = this.acm == 0;
        for (var m = 0; m < e; m++) {
            var n = Math.floor(d.af._inner[m]);
            var o = Math.floor(d.ag._inner[m]);
            var p = null;
            if (k) {
                if (isNaN_(n)) {
                    continue;
                }
                var q = this.abe(c, f, m, d, true);
                p = q.c;
                f = q.d;
                var r = new PathGeometry();
                var s = new PathFigure();
                s._startPoint = { $type: Point_$type, x: o, y: i };
                var t = new LineSegment(1);
                t.c = { $type: Point_$type, x: o, y: j };
                s._segments.add(t);
                r.c.add(s);
                p.an = r;
            }
            if (l) {
                if (isNaN_(n)) {
                    continue;
                }
                var u = this.abe(c, f, m, d, false);
                p = u.c;
                f = u.d;
                var v = new PathGeometry();
                var w = new PathFigure();
                w._startPoint = { $type: Point_$type, x: g, y: n };
                var x = new LineSegment(1);
                x.c = { $type: Point_$type, x: h, y: n };
                w._segments.add(x);
                v.c.add(w);
                p.an = v;
            }
        }
        c.count = f;
        if (this.d3()) {
            this.abg(this.xb, true);
        }
        else {
            this.abg(this.w9, false);
        }
    };
    CrosshairLayer.prototype.ga = function () {
        return true;
    };
    CrosshairLayer.prototype.q7 = function (a, b, c, d) {
        _super.prototype.q7.call(this, a, b, c, d);
        switch (b) {
            case "SeriesViewer":
                if (d == null) {
                    if (this.z4 != null && this.z4.count > 0) {
                        var e = void 0;
                        if (this.d3()) {
                            e = this.xb;
                        }
                        else {
                            e = this.w9;
                        }
                        AxisAnnotationFrameManager.b(e);
                        AxisAnnotationFrameManager.d(this, e, true, this.z4, this.z5, true, this.aai, this.aaj, this.xAxisAnnotationFormatLabel, this.yAxisAnnotationFormatLabel);
                    }
                }
                break;
            case CrosshairLayer.$$p[1]:
                this.rp(true);
                break;
            case CrosshairLayer.$$p[8]:
                this.rp(true);
                break;
            case CrosshairLayer.$$p[4]:
            case CrosshairLayer.$$p[5]:
                this.rp(true);
                break;
            case CrosshairLayer.$$p[2]:
            case CrosshairLayer.$$p[10]:
            case CrosshairLayer.$$p[9]:
            case CrosshairLayer.$$p[12]:
            case CrosshairLayer.$$p[14]:
            case CrosshairLayer.$$p[16]:
            case CrosshairLayer.$$p[15]:
            case CrosshairLayer.$$p[13]:
            case CrosshairLayer.$$p[17]:
            case CrosshairLayer.$$p[18]:
            case CrosshairLayer.$$p[20]:
            case CrosshairLayer.$$p[22]:
            case CrosshairLayer.$$p[24]:
            case CrosshairLayer.$$p[26]:
            case CrosshairLayer.$$p[25]:
            case CrosshairLayer.$$p[23]:
            case CrosshairLayer.$$p[27]:
            case CrosshairLayer.$$p[28]:
            case CrosshairLayer.$$p[0]:
            case CrosshairLayer.$$p[7]:
            case CrosshairLayer.$$p[6]:
                this.rp(true);
                break;
        }
    };
    CrosshairLayer.$t = markType(CrosshairLayer, 'CrosshairLayer', AnnotationLayer.$);
    CrosshairLayer.$$p = markDep(DependencyProperty, PropertyMetadata, CrosshairLayer, 'raisePropertyChanged', ['HorizontalLineStroke:aca:abh', [Brush.$, null], 'HorizontalLineVisibility:acm:abi', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'IsAxisAnnotationEnabled:z1:abj', [0, false], 'SkipUnknownValues:z2:abk', [0, true], 'TargetSeriesName:aao:abl', [2, null], 'TargetSeries:zy:abm', [Series.$, null], 'UseInterpolation:z3:abn', [0, true], 'VerticalLineStroke:acb:abo', [Brush.$, null], 'VerticalLineVisibility:acn:abp', [Visibility_$type, enumGetBox(Visibility_$type, 0)], 'XAxisAnnotationBackgroundCornerRadius:z6:abq', [1, DeviceUtils.g(3)], 'XAxisAnnotationBackground:acc:abr', [Brush.$, null], 'XAxisAnnotationInterpolatedValuePrecision:aai:abs', [1, -1], 'XAxisAnnotationOutline:acd:abt', [Brush.$, null], 'XAxisAnnotationPaddingBottom:z7:abu', [1, NaN], 'XAxisAnnotationPaddingLeft:z8:abv', [1, NaN], 'XAxisAnnotationPaddingRight:z9:abw', [1, NaN], 'XAxisAnnotationPaddingTop:aaa:abx', [1, NaN], 'XAxisAnnotationStrokeThickness:aab:aby', [1, NaN], 'XAxisAnnotationTextColor:ace:abz', [Brush.$, null], 'YAxisAnnotationBackgroundCornerRadius:aac:ab0', [1, DeviceUtils.g(3)], 'YAxisAnnotationBackground:acf:ab1', [Brush.$, null], 'YAxisAnnotationInterpolatedValuePrecision:aaj:ab2', [1, -1], 'YAxisAnnotationOutline:acg:ab3', [Brush.$, null], 'YAxisAnnotationPaddingBottom:aad:ab4', [1, NaN], 'YAxisAnnotationPaddingLeft:aae:ab5', [1, NaN], 'YAxisAnnotationPaddingRight:aaf:ab6', [1, NaN], 'YAxisAnnotationPaddingTop:aag:ab7', [1, NaN], 'YAxisAnnotationStrokeThickness:aah:ab8', [1, NaN], 'YAxisAnnotationTextColor:ach:ab9', [Brush.$, null]]);
    return CrosshairLayer;
}(AnnotationLayer));
export { CrosshairLayer };
/**
 * @hidden
 */
var CrosshairLayerView = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CrosshairLayerView, _super);
    function CrosshairLayerView(a) {
        var _this = _super.call(this, a) || this;
        _this.b7 = null;
        _this.b8 = null;
        _this.b9 = null;
        _this.b7 = a;
        _this.b9 = new List$1(Path.$, 0);
        return _this;
    }
    CrosshairLayerView.prototype.au = function () {
        var _this = this;
        _super.prototype.au.call(this);
        this.b8 = ((function () {
            var $ret = new Pool$1(Path.$);
            $ret.create = runOn(_this, _this.ch);
            $ret.activate = runOn(_this, _this.ca);
            $ret.disactivate = runOn(_this, _this.cc);
            $ret.destroy = runOn(_this, _this.cb);
            return $ret;
        })());
        this.b7.jp = Defaults.j;
    };
    CrosshairLayerView.prototype.ch = function () {
        var a = new Path();
        a.j = new TranslateTransform();
        this.b9.add(a);
        return a;
    };
    CrosshairLayerView.prototype.ca = function (a) {
        a._visibility = 0;
    };
    CrosshairLayerView.prototype.cc = function (a) {
        a._visibility = 1;
    };
    CrosshairLayerView.prototype.cb = function (a) {
        this.b9.remove(a);
    };
    CrosshairLayerView.prototype.cd = function (a, b, c, d) {
        if (a.an == null || a.an.c.x != d || a.an.d.x != c) {
            var e = ((function () {
                var $ret = new LineGeometry();
                $ret.d = { $type: Point_$type, x: c, y: b };
                $ret.c = { $type: Point_$type, x: d, y: b };
                return $ret;
            })());
            a.an = e;
        }
    };
    CrosshairLayerView.prototype.ce = function (a, b) {
        if (a == null) {
            return a;
        }
        return BrushUtil.m(a, b);
    };
    CrosshairLayerView.prototype.cg = function (a, b) {
        if (a == null) {
            return a;
        }
        return BrushUtil.o(a, b);
    };
    CrosshairLayerView.prototype.cf = function (a, b) {
        if (a == null) {
            return a;
        }
        var c = new Brush();
        c.color = Color.u(truncate((a.color.l * b)), a.color.o, a.color.n, a.color.m);
        return c;
    };
    CrosshairLayerView.prototype.a8 = function (a, b) {
        _super.prototype.a8.call(this, a, b);
        if (a.d && !b) {
            for (var c = 0; c < this.b9.count; c++) {
                var d = this.b9._inner[c];
                if (d._visibility == 0) {
                    a.t(d);
                }
            }
        }
    };
    CrosshairLayerView.prototype.an = function (a) {
        _super.prototype.an.call(this, a);
        for (var b = 0; b < this.b9.count; b++) {
            this.e.bc.exportPathData(a, this.b9._inner[b], "crosshairLine", ["Main", "Crosshair"]);
        }
    };
    CrosshairLayerView.$t = markType(CrosshairLayerView, 'CrosshairLayerView', AnnotationLayerView.$);
    return CrosshairLayerView;
}(AnnotationLayerView));
export { CrosshairLayerView };
